FUNCTION Calendar(loTextEdit)
	LOCAL loChangeDate AS OBJECT
	loChangeDate=CREATEOBJECT("cdate",loTextEdit)
	loChangeDate.SHOW(1)
	RETURN
ENDFUNC

DEFINE CLASS daylabel AS LABEL
	FONTSIZE=8
	FONTBOLD=.T.
	HEIGHT=16
	WIDTH=18
	ALIGNMENT=2
	BORDERSTYLE=0
	BACKCOLOR=RGB(250,250,250)
	CAPTION=""
	PROCEDURE CLICK
		LOCAL vdt
		vdt=CTOD(THIS.CAPTION+"."+ALLT(STR(THIS.PARENT.vmonth))+"."+ALLT(STR(THIS.PARENT.vyear)))
		IF ! EMPTY(vdt)
			DO CASE
				CASE TYPE("thisform.odat")="D"
					THISFORM.odat=vdt
				CASE TYPE("thisform.odat")="O"
					THISFORM.odat.VALUE=vdt
					THISFORM.odat.REFRESH
			ENDCASE
		ENDIF
		THIS.PARENT.RELEASE
	ENDPROC
	PROCEDURE MOUSEMOVE
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		IF ! EMPTY(THIS.CAPTION)
			IF THIS.PARENT.vday!=VAL(THIS.CAPTION)
				THIS.PARENT.vday=VAL(THIS.CAPTION)
				THIS.PARENT.olm.CAPTION=ALLT(STR(THIS.PARENT.vday))+" "+THIS.PARENT.mns[this.parent.vmonth]+" "+ALLT(STR(THIS.PARENT.vyear))
			ENDIF
		ENDIF
	ENDPROC
	PROCEDURE RIGHTCLICK
		THISFORM.RELEASE
	ENDPROC
ENDDEFINE

DEFINE CLASS cdcommandbutton AS COMMANDBUTTON
	FONTBOLD=.T.
	FONTSIZE=8
	TOP=21
	WIDTH=26
	HEIGHT=16
	VISIBLE=.T.
	TABSTOP=.F.
ENDDEFINE

DEFINE CLASS dowlabel AS LABEL
	FONTSIZE=8
	FONTBOLD=.F.
	HEIGHT=16
	WIDTH=18
	ALIGNMENT=2
	BORDERSTYLE=0
	TOP=39
	BACKCOLOR=RGB(0,0,254)
	FORECOLOR=RGB(254,254,254)
ENDDEFINE

DEFINE CLASS cDate AS FORM
	odat=.F.
	HEIGHT=161
	WIDTH=135
	BORDERSTYLE=1
	TITLEBAR=0
	SHOWTIPS=.T.
	vday=0
	vmonth=0
	vyear=0
	vd=DATE()
	DECLARE mns[12]
	mns[1]=""
	mns[2]=""
	mns[3]=""
	mns[4]=""
	mns[5]=""
	mns[6]=""
	mns[7]=""
	mns[8]=""
	mns[9]=""
	mns[10]=""
	mns[11]=""
	mns[12]=""
	ADD OBJECT "obml" AS "cdcommandbutton"
	ADD OBJECT "obmr" AS "cdcommandbutton"
	ADD OBJECT "obtd" AS "cdcommandbutton"
	ADD OBJECT "obyl" AS "cdcommandbutton"
	ADD OBJECT "obyr" AS "cdcommandbutton"
	ADD OBJECT "tmer" AS "timer"
	tmer.CYCL=0
	PROCEDURE INIT
		PARAMETERS  cDate
		IF PARAMETERS()=0
			cDate=DATE()
		ENDIF
		_scw=_SCREEN.WIDTH
		_sch=_SCREEN.HEIGHT
		_mc=MCOL("",3)
		_mr=MROW("",3)
		DO CASE
			CASE (_sch-_mr>THIS.HEIGHT).AND.(_scw-_mc>THIS.WIDTH)
				THIS.LEFT=_mc-3
				THIS.TOP=_mr-3
			CASE (_sch-THIS.HEIGHT>0).AND.(_scw-_mc>THIS.WIDTH)
				THIS.LEFT=_mc-3
				THIS.TOP=_mr+3-THIS.HEIGHT
			CASE (_sch-_mr>THIS.HEIGHT).AND.(_scw-THIS.WIDTH>0)
				THIS.LEFT=_mc+3-THIS.WIDTH
				THIS.TOP=_mr-3
			CASE (_sch-THIS.HEIGHT>0).AND.(_scw-THIS.WIDTH>0)
				THIS.LEFT=_mc+3-THIS.WIDTH
				THIS.TOP=_mr+3-THIS.HEIGHT
			OTHERWISE
				THIS.LEFT=_mc-THIS.WIDTH/2
				THIS.TOP=_mr-THIS.HEIGHT/2
		ENDCASE
		SET DATE FRENCH
		THIS.odat=cDate
		DO CASE
			CASE TYPE("cDate")="D"
				THIS.vd=cDate
				THIS.vday=IIF(EMPTY(cDate),DAY(DATE()),DAY(cDate))
				THIS.vmonth=IIF(EMPTY(cDate),MONTH(DATE()),MONTH(cDate))
				THIS.vyear=IIF(EMPTY(cDate),YEAR(DATE()),YEAR(cDate))
			CASE TYPE("cDate")="O"
				THIS.vd=cDate.VALUE
				THIS.vday=IIF(EMPTY(cDate.VALUE),DAY(DATE()),DAY(cDate.VALUE))
				THIS.vmonth=IIF(EMPTY(cDate.VALUE),MONTH(DATE()),MONTH(cDate.VALUE))
				THIS.vyear=IIF(EMPTY(cDate.VALUE),YEAR(DATE()),YEAR(cDate.VALUE))
		ENDCASE

		THIS.ADDOBJECT("olm","label")
		WITH THIS.olm
			.FONTBOLD=.T.
			.FONTSIZE=8
			.BORDERSTYLE=1
			.BACKCOLOR=RGB(255,255,255)
			.TOP=2
			.WIDTH=131
			.ALIGNMENT=2
			.HEIGHT=18
			.VISIBLE=.T.
			.LEFT=(THISFORM.WIDTH-.WIDTH)/2
		ENDWITH

		WITH THIS.obml
			.TOOLTIPTEXT=" "
			.CAPTION="<"
			.LEFT=28
		ENDWITH

		WITH THIS.obtd
			.TOOLTIPTEXT=""
			.CAPTION="*"
			.LEFT=THISFORM.WIDTH/2-12
		ENDWITH


		WITH THIS.obmr
			.TOOLTIPTEXT=" "
			.CAPTION=">"
			.LEFT=THISFORM.WIDTH-53
		ENDWITH

		WITH THIS.obyl
			.TOOLTIPTEXT=" "
			.CAPTION="<<"
			.LEFT=2
		ENDWITH

		WITH THIS.obyr
			.TOOLTIPTEXT=" "
			.CAPTION=">>"
			.LEFT=THISFORM.WIDTH-27
		ENDWITH

		FOR i=1 TO 7
			THIS.ADDOBJECT("old"+ALLT(STR(i)),"dowlabel")
			us="no=this.old"+ALLT(STR(i))
			&us
			WITH no
				.LEFT=2+(i-1)*(.WIDTH+1)
				DO CASE
					CASE i=1
						.CAPTION=""
					CASE i=2
						.CAPTION=""
					CASE i=3
						.CAPTION=""
					CASE i=4
						.CAPTION=""
					CASE i=5
						.CAPTION=""
					CASE i=6
						.CAPTION=""
						.BACKCOLOR=RGB(254,0,0)
						.FORECOLOR=RGB(254,254,254)
					CASE i=7
						.CAPTION=""
						.BACKCOLOR=RGB(254,0,0)
						.FORECOLOR=RGB(254,254,254)
				ENDCASE
				.VISIBLE=.T.
			ENDWITH
		NEXT
		nomb=0
		FOR N=1 TO 6
			FOR i=1 TO 7
				nomb=nomb+1
				THIS.ADDOBJECT("oldy"+ALLT(STR(nomb)),"daylabel")
				us="no=this.oldy"+ALLT(STR(nomb))
				&us
				WITH no
					.TOP=57+(N-1)*(.HEIGHT+1)
					.LEFT=2+(i-1)*(.WIDTH+1)
					.VISIBLE=.T.
				ENDWITH
			NEXT
		NEXT
		THIS.DRAW
	ENDPROC

	PROCEDURE setday
		LOCAL fdd,fd,i,N,us
		fdd=CTOD("01."+ALLT(STR(THIS.vmonth))+"."+ALLT(STR(THIS.vyear)))
		fd=DOW(fdd)
		fd=IIF(fd=1,7,fd-1)
		FOR i=1 TO fd-1
			us="this.oldy"+ALLT(STR(i))+".visible=.f."
			&us
		NEXT
		FOR i=1 TO 40
			us="eobj=this.oldy"+ALLT(STR(fd+i-1))
			&us
			eobj.CAPTION=ALLT(STR(i))
			eobj.VISIBLE=.T.
			edat=CTOD(ALLT(STR(i))+"."+ALLT(STR(THIS.vmonth))+"."+ALLT(STR(THIS.vyear)))
			DO CASE
				CASE edat=THIS.vd
					eobj.BACKCOLOR=RGB(250,150,150)
					eobj.TOOLTIPTEXT=' '
				CASE edat=DATE()
					eobj.BACKCOLOR=RGB(150,250,150)
					eobj.TOOLTIPTEXT=''
				OTHERWISE
					eobj.BACKCOLOR=RGB(250,250,250)
					eobj.TOOLTIPTEXT=''
			ENDCASE
			IF MONTH(fdd)!=MONTH(fdd+i)
				EXIT
			ENDIF
		NEXT
		ezn=(fd+i-1)/7
		_colday=IIF(ezn=INT(ezn),ezn,INT(ezn)+1)
		THIS.HEIGHT=161-(17*(6-_colday))
		FOR N=fd+i TO 42
			us="this.oldy"+ALLT(STR(N))+".visible=.f."
			&us
		NEXT
	ENDPROC

	PROCEDURE DRAW
		THIS.vday=1
		THIS.olm.CAPTION=ALLT(STR(THIS.vday))+" "+THIS.mns[this.vmonth]+" "+ALLT(STR(THIS.vyear))
		THISFORM.setday
	ENDPROC

	PROCEDURE obml.CLICK
		IF THISFORM.vmonth=1
			THISFORM.vmonth=12
			THISFORM.vyear=THISFORM.vyear-1
		ELSE
			THISFORM.vmonth=THISFORM.vmonth-1
		ENDIF
		THISFORM.DRAW
	ENDPROC

	PROCEDURE obtd.CLICK
		THISFORM.vmonth=MONTH(DATE())
		THISFORM.vyear=YEAR(DATE())
		THISFORM.DRAW
	ENDPROC

	PROCEDURE obmr.CLICK
		IF THISFORM.vmonth=12
			THISFORM.vmonth=1
			THISFORM.vyear=THISFORM.vyear+1
		ELSE
			THISFORM.vmonth=THISFORM.vmonth+1
		ENDIF
		THISFORM.DRAW
	ENDPROC

	PROCEDURE obyl.CLICK
		THISFORM.vyear=THISFORM.vyear-1
		THISFORM.DRAW
	ENDPROC

	PROCEDURE obyr.CLICK
		THISFORM.vyear=THISFORM.vyear+1
		THISFORM.DRAW
	ENDPROC

	PROCEDURE CLICK
		THIS.RELEASE
	ENDPROC

	PROCEDURE tmer.INIT
		THIS.INTERVAL=100
	ENDPROC

	PROCEDURE tmer.TIMER
		LOCAL xval,yval
		xval=MROW(THISFORM.CAPTION,3)
		yval=MCOL(THISFORM.CAPTION,3)
		IF xval<0.OR.yval<0
			THIS.CYCL=THIS.CYCL+1
		ELSE
			THIS.CYCL=0
		ENDIF
		IF THIS.CYCL=10
			THISFORM.RELEASE
		ENDIF
	ENDPROC
ENDDEFINE
